## breezy 3.0.0~bzr7210

=== Makefile ===
# Copyright (C) 2005-2012, 2016, 2017 Canonical Ltd
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

# A relatively simple Makefile to assist in building parts of brz. Mostly for
# building documentation, etc.


### Core Stuff ###

SHELL=bash
PYTHON?=python
PYTHON3?=python3
PYTHON24=python24
PYTHON25=python25
PYTHON26=python26
BRZ_TARGET=release
PLUGIN_TARGET=plugin-release
PYTHON_BUILDFLAGS=
BRZ_PLUGIN_PATH=-site:-user

# Shorter replacement for $(sort $(wildcard <arg>)) as $(call sw,<arg>)
sw = $(sort $(wildcard $(1)))


.PHONY: all clean realclean extensions flake8 api-docs check-nodocs check

all: extensions

extensions:
	@echo "building extension modules."
	$(PYTHON) setup.py build_ext -i $(PYTHON_BUILDFLAGS)

check: docs check-nodocs

check-nodocs: check-nodocs2 check-nodocs3

check-nodocs3:
	# Generate a stream for PQM to watch.
	-$(RM) -f selftest.log
	echo `date` ": selftest starts" 1>&2
	set -o pipefail; BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -Wignore::PendingDeprecationWarning -Wignore::DeprecationWarning -O \
	  ./brz selftest -Oselftest.timeout=120 --strict \
	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
	echo `date` ": selftest ends" 1>&2
	# An empty log file should catch errors in the $(PYTHON3)
	# command above (the '|' swallow any errors since 'make'
	# sees the 'tee' exit code for the whole line
	if [ ! -s selftest.log ] ; then exit 1 ; fi
	# Check that there were no errors reported.
	subunit-stats < selftest.log

check-nodocs2: extensions
	# Generate a stream for PQM to watch.
	-$(RM) -f selftest.log
	echo `date` ": selftest starts" 1>&2
	set -o pipefail; BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
	  ./brz selftest -Oselftest.timeout=120 \
	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
	echo `date` ": selftest ends" 1>&2
	# An empty log file should catch errors in the $(PYTHON)
	# command above (the '|' swallow any errors since 'make'
	# sees the 'tee' exit code for the whole line
	if [ ! -s selftest.log ] ; then exit 1 ; fi
	# Check that there were no errors reported.
	subunit-stats < selftest.log

check-ci: docs extensions
	# FIXME: Remove -Wignore::FutureWarning once
	# https://github.com/paramiko/paramiko/issues/713 is not a concern
	# anymore -- vila 2017-05-24
	set -o pipefail; \
	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::FutureWarning -Wignore::DeprecationWarning -Wignore::ImportWarning -Wignore::ResourceWarning -O \
	  ./brz selftest -v --parallel=fork -Oselftest.timeout=120 --subunit2 \
	  | subunit-filter -s --passthrough --rename "^" "python2."; \
	  BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::FutureWarning -Wignore::DeprecationWarning -Wignore::PendingDeprecationWarning -Wignore::ImportWarning -Wignore::ResourceWarning -O \
	  ./brz selftest -v --parallel=fork -Oselftest.timeout=120 --subunit2 \
	  | subunit-filter -s --passthrough --rename "^" "python3."

# Run Python style checker (apt-get install flake8)
#
# Note that at present this gives many false warnings, because it doesn't
# know about identifiers loaded through lazy_import.
flake8:
	flake8

clean:
	$(PYTHON) setup.py clean
	-find . -name "*.pyc" -o -name "*.pyo" -o -name "*.so" | xargs rm -f

realclean: clean
	# Remove files which are autogenerated but included by the tarball.
	rm -f breezy/*_pyx.c breezy/bzr/*_pyx.c
	rm -f breezy/_simple_set_pyx.h breezy/_simple_set_pyx_api.h

# build tags for emacs and vim
TAGS:
	ctags -R -e breezy

tags:
	ctags -R breezy

# these are treated as phony so they'll always be rebuilt - it's pretty quick
.PHONY: TAGS tags


### Documentation ###

docs: docs-sphinx

clean-docs: clean-sphinx

html-docs: html-sphinx


### Man-page Documentation ###

MAN_DEPENDENCIES = breezy/builtins.py \
	$(call sw,breezy/*.py) \
	$(call sw,breezy/*/*.py) \
	tools/generate_docs.py \
	$(call sw,$(addsuffix /*.txt, breezy/help_topics/en)) 

MAN_PAGES = man1/brz.1
man1/brz.1: $(MAN_DEPENDENCIES)
	mkdir -p $(dir $@)
	$(PYTHON) tools/generate_docs.py -o $@ man


### Sphinx-style Documentation ###

# Build the documentation. To keep the dependencies down to a minimum
# for distro packagers, we only build the html documentation by default.
# Sphinx 0.6 or later is preferred for the best rendering, though
# Sphinx 0.4 or later should work. See http://sphinx.pocoo.org/index.html
# for installation instructions.
docs-sphinx: html-sphinx

# Clean out generated documentation
clean-sphinx:
	$(MAKE) -C doc/en clean
	$(MAKE) -C doc/developers clean

SPHINX_DEPENDENCIES = \
        doc/en/release-notes/index.txt \
        doc/en/user-reference/index.txt \
	doc/developers/Makefile \
	doc/developers/make.bat

NEWS_FILES = $(call sw,doc/en/release-notes/brz-*.txt)

doc/en/user-reference/index.txt: $(MAN_DEPENDENCIES)
	LANGUAGE=C $(PYTHON) tools/generate_docs.py -o $@ rstx

doc/en/release-notes/index.txt: $(NEWS_FILES) tools/generate_release_notes.py
	$(PYTHON) tools/generate_release_notes.py $@ $(NEWS_FILES)

doc/%/Makefile: doc/en/Makefile
	$(PYTHON) -c "import shutil; shutil.copyfile('$<', '$@')"

doc/%/make.bat: doc/en/make.bat
	$(PYTHON) -c "import shutil; shutil.copyfile('$<', '$@')"

# Build the html docs using Sphinx.
html-sphinx: $(SPHINX_DEPENDENCIES)
	$(MAKE) -C doc/en html
	$(MAKE) -C doc/developers api html

# Build the PDF docs using Sphinx. This requires numerous LaTeX
# packages. See http://sphinx.pocoo.org/builders.html for details.
# Note: We don't currently build PDFs for the Russian docs because
# they require additional packages to be installed (to handle
# Russian hyphenation rules, etc.)
pdf-sphinx: $(SPHINX_DEPENDENCIES)
	$(MAKE) -C doc/en latex
	$(MAKE) -C doc/developers latex
	$(MAKE) -C doc/en/_build/latex all-pdf
	$(MAKE) -C doc/developers/_build/latex all-pdf

# Build the CHM (Windows Help) docs using Sphinx.
# Note: HtmlHelp Workshop needs to be used on the generated hhp files
# to generate the final chm files.
chm-sphinx: $(SPHINX_DEPENDENCIES)
	$(MAKE) -C doc/en htmlhelp
	$(MAKE) -C doc/developers htmlhelp


# Build the texinfo files using Sphinx.
texinfo-sphinx: $(SPHINX_DEPENDENCIES)
	$(MAKE) -C doc/en texinfo
	$(MAKE) -C doc/developers texinfo

### Documentation Website ###

# Where to build the website
DOC_WEBSITE_BUILD = build_doc_website

# Build and package docs into a website, complete with downloads.
doc-website: html-sphinx pdf-sphinx
	$(PYTHON) tools/package_docs.py doc/en $(DOC_WEBSITE_BUILD)
	$(PYTHON) tools/package_docs.py doc/developers $(DOC_WEBSITE_BUILD)


### Miscellaneous Documentation Targets ###

# build a png of our performance task list
# this is no longer built by default; you can build it if you want to look at it
doc/developers/performance.png: doc/developers/performance.dot
	@echo Generating $@
	@dot -Tpng $< -o$@ || echo "Dot not installed; skipping generation of $@"


### Windows Support ###

# make all the installers completely from scratch, using zc.buildout
# to fetch the dependencies
# These are files that need to be copied into the build location to boostrap
# the build process.
# Note that the path is relative to tools/win32
BUILDOUT_FILES = buildout.cfg \
	buildout-templates/bin/build-installer.bat.in \
	ostools.py bootstrap.py

installer-all:
	@echo Make all the installers from scratch
	@# Build everything in a separate directory, to avoid cluttering the WT
	$(PYTHON) tools/win32/ostools.py makedir build-win32
	@# cd to tools/win32 so that the relative paths are copied correctly
	cd tools/win32 && $(PYTHON) ostools.py copytree $(BUILDOUT_FILES) ../../build-win32
	@# There seems to be a bug in gf.release.brz, It doesn't correctly update
	@# existing release directories, so delete them manually before building
	@# It means things may be rebuilt that don't need to be, but at least
	@# it will be correct when they do.
	cd build-win32 && $(PYTHON) ostools.py remove release */release
	cd build-win32 && $(PYTHON) bootstrap.py
	cd build-win32 && bin/buildout
	cd build-win32 && bin/build-installer.bat $(BRZ_TARGET) $(PLUGIN_TARGET)


clean-installer-all:
	$(PYTHON) tools/win32/ostools.py remove build-win32

# make brz.exe for win32 with py2exe
exe:
	@echo *** Make brz.exe
	$(PYTHON) tools/win32/ostools.py remove breezy/*.pyd
	$(PYTHON) setup.py build_ext -i -f $(PYTHON_BUILDFLAGS)
	$(PYTHON) setup.py py2exe > py2exe.log
	$(PYTHON) tools/win32/ostools.py copytodir tools/win32/start_brz.bat win32_brz.exe
	$(PYTHON) tools/win32/ostools.py copytodir tools/win32/bazaar.url win32_brz.exe

# win32 installer for brz.exe
installer: exe copy-docs
	@echo *** Make Windows installer
	$(PYTHON) tools/win32/run_script.py cog.py -d -o tools/win32/brz.iss tools/win32/brz.iss.cog
	iscc /Q tools/win32/brz.iss

# win32 Python's distutils-based installer
# require to have Python interpreter installed on win32
py-inst-24: docs
	$(PYTHON24) setup.py bdist_wininst --install-script="brz-win32-bdist-postinstall.py" -d .

py-inst-25: docs
	$(PYTHON25) setup.py bdist_wininst --install-script="brz-win32-bdist-postinstall.py" -d .

py-inst-26: docs
	$(PYTHON26) setup.py bdist_wininst --install-script="brz-win32-bdist-postinstall.py" -d .

python-installer: py-inst-24 py-inst-25 py-inst-26


copy-docs: docs
	$(PYTHON) tools/win32/ostools.py copytodir README win32_brz.exe/doc
	$(PYTHON) tools/win32/ostools.py copytree $(WEB_DOCS) win32_brz.exe

# clean on win32 all installer-related files and directories
clean-win32: clean-docs
	$(PYTHON) tools/win32/ostools.py remove build
	$(PYTHON) tools/win32/ostools.py remove win32_brz.exe
	$(PYTHON) tools/win32/ostools.py remove py2exe.log
	$(PYTHON) tools/win32/ostools.py remove tools/win32/brz.iss
	$(PYTHON) tools/win32/ostools.py remove brz-setup*.exe
	$(PYTHON) tools/win32/ostools.py remove brz-*win32.exe
	$(PYTHON) tools/win32/ostools.py remove dist


# i18n targets

.PHONY: update-pot po/brz.pot
update-pot: po/brz.pot

TRANSLATABLE_PYFILES:=$(shell find breezy -name '*.py' \
		| grep -v 'breezy/tests/' \
		| grep -v 'breezy/doc' \
		)

po/brz.pot: $(PYFILES) $(DOCFILES)
	$(PYTHON) ./brz export-pot --include-duplicates > po/brz.pot
	echo $(TRANSLATABLE_PYFILES) | xargs \
	  xgettext --package-name "brz" \
	  --msgid-bugs-address "<bazaar@canonical.com>" \
	  --copyright-holder "Canonical" \
	  --from-code ISO-8859-1 --join --sort-by-file --add-comments=i18n: \
	  -d bzr -p po -o brz.pot


### Packaging Targets ###

.PHONY: dist check-dist-tarball

# build a distribution source tarball
dist: 
	version=`./brz version --short` && \
	echo Building distribution of brz $$version && \
	expbasedir=`mktemp -t -d tmp_brz_dist.XXXXXXXXXX` && \
	expdir=$$expbasedir/brz-$$version && \
	tarball=$$PWD/../breezy-$$version.tar.gz && \
	$(MAKE) clean && \
	$(MAKE) && \
	$(PYTHON) setup.py sdist -d $$PWD/.. && \
	gpg --detach-sign --armor $$tarball && \
	rm -rf $$expbasedir

# run all tests in a previously built tarball
check-dist-tarball:
	tmpdir=`mktemp -t -d tmp_brz_check_dist.XXXXXXXXXX` && \
	version=`./brz version --short` && \
	tarball=$$PWD/../breezy-$$version.tar.gz && \
	tar Cxz $$tmpdir -f $$tarball && \
	$(MAKE) -C $$tmpdir/breezy-$$version check && \
	rm -rf $$tmpdir

=== debian/changelog ===
breezy (3.0.0~bzr7210-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 28 Nov 2018 04:04:17 +0000

breezy (3.0.0~bzr7210-3) unstable; urgency=medium

  * Add patch 10_timestamp_limit: take into account offset when checking
    for time overflow.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 24 Nov 2018 22:57:31 +0000

breezy (3.0.0~bzr7210-2) unstable; urgency=medium

  * debci: Run with plugins enabled, since some tests rely on plugins being
    loaded.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 24 Nov 2018 15:34:03 +0000

breezy (3.0.0~bzr7210-1) unstable; urgency=medium

  * Mark brz-doc as Multi-Arch: foreign.
  * Add patch 05_timestamp_range: Handle overflow on Python 2.
  * Add patch 09_python_3.7: fix compatibility with Python 3.7.
  * New upstream snapshot.
  * Drop patch 04_remove_more_file_ids: applied upstream.
  * Drop patch 05_timestamp_range: applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 23 Nov 2018 12:05:17 +0000

breezy (3.0.0~bzr7204-1) unstable; urgency=medium

  * debian/control: Mention in long description that Breezy supports the
    Git and Bazaar file formats.
  * New upstream snapshot.
   + Drop patch 09_increase_time_window: applied upstream.
   + Drop patch 06_git_ignore: applied upstream.
   + Drop patch 07_empty_dir_changed: applied upstream.
  * Add CI configuration for Salsa.
  * debian/tests/control: Fix dependency on python-dulwich to use at least
    0.19.8.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 21 Nov 2018 20:11:22 +0000

breezy (3.0.0~bzr7199-2) unstable; urgency=medium

  * Set selftest timeout to 6000 seconds, to help with slow buildds.
  * Add patch 09_increase_time_window: allow more slack when comparing
    mtimes, for slow systems.
  * debian/control: Fix dependency on python-dulwich to use at least
    0.19.8.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Tue, 20 Nov 2018 17:36:21 +0000

breezy (3.0.0~bzr7199-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add patch 04_remove_more_file_ids: fix some compatibility issues.
  * Add patch 06_git_ignore: fix 'brz ignore' in git repositories.
  * Bump python-gpg from suggests to recommends.
  * Add patch 07_empty_dir_changed: don't consider empty git directories
    when finding unknown files.
  * Add patch 08_disable_sphinx_epytext.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Tue, 20 Nov 2018 01:10:38 +0000

breezy (3.0.0~bzr7192-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 18 Nov 2018 02:58:16 +0000

breezy (3.0.0~bzr7190-1) unstable; urgency=medium

  * Bump minimum version of dulwich to 0.19.8.
  * Add note about python version to python{,3}-breezy.tests long
    description.
  * debian/copyright: Remove duplicate paragraph for tools/brz_access.
  * New upstream snapshot.
  * Drop patch 03_crc_asul and 15_git_feature: applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 17 Nov 2018 19:39:10 +0000

breezy (3.0.0~bzr7183-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add patch 03_crc_asul to fix test failures on 32-bit platforms.
    Closes: #908984
  * Drop patch 04_spurious_test_failure: fixed upstream.
  * Drop patch 15_executable: fixed upstream.
  * 01_selftest_package: refresh.
  * Add 15_git_feature: add missing feature requirement.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 17 Nov 2018 10:47:34 +0000

breezy (3.0.0~bzr7141-4) unstable; urgency=medium

  * Refresh patch 15_executable to include other uses of 'python'.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 31 Oct 2018 22:37:51 +0000

breezy (3.0.0~bzr7141-3) unstable; urgency=medium

  * Add patch 15_executable: Don't asssume 'python' is available now
    that breezy uses Python 3 by default. Closes: #912102

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 28 Oct 2018 11:44:00 +0000

breezy (3.0.0~bzr7141-2) unstable; urgency=medium

  * Use correct machine-readable copyright file URI.
  * Trim trailing whitespace.
  * Transition to automatic debug packages (from: python-breezy-dbg,
    python3-breezy-dbg).
  * Remove unnecessary XS-Testsuite field in debian/control.
  * Add patch 04_spurious_test_failure: ignore failures frmo
    test_missing_chk_leaf_for_inventory tests, which occasionally fail.
  * Drop build-dependency on python-lzma-dbg, now gone from the archive.
    Closes: #911945

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 14 Oct 2018 19:16:26 +0000

breezy (3.0.0~bzr7141-1) unstable; urgency=medium

  * New upstream snapshot.
   + Fixes Git operations over HTTP.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 14 Oct 2018 16:48:21 +0000

breezy (3.0.0~bzr7140-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 14 Oct 2018 02:08:12 +0100

breezy (3.0.0~bzr7131-2) unstable; urgency=medium

  * Use Python 3 version in brz package.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 12 Oct 2018 18:38:19 +0100

breezy (3.0.0~bzr7131-1) unstable; urgency=medium

  * New upstream snapshot.
   + Drop 14_test_server: applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 30 Sep 2018 20:23:52 +0100

breezy (3.0.0~bzr7119-1) unstable; urgency=medium

  * New upstream snapshot.
  * Support alpha releases in watch.
  * Add upstream signing keys.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 16 Sep 2018 09:32:53 +0100

breezy (3.0.0~bzr7111-1) unstable; urgency=medium

  * New upstream snapshot.
    + Drop patches exclude_broken and skip_readdir_on_python3; applied
      upstream.
    + Drop use of python3.passing; all python3 tests pass now.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 14 Sep 2018 13:05:24 +0100

breezy (3.0.0~bzr7096-2) unstable; urgency=medium

  * Add debian upstream metadata.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 08 Sep 2018 19:19:56 +0100

breezy (3.0.0~bzr7096-1) unstable; urgency=medium

  * New upstream snapshot.


=== debian/control ===
Source: breezy
Section: vcs
Priority: optional
Maintainer: Debian Breezy Maintainers <pkg-bazaar-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>
Build-Depends: bash-completion,
               ca-certificates,
               cython-dbg (>= 0.17) <!nocheck>,
               dh-python,
               debhelper (>= 9.20160114),
               fdupes,
               python (>= 2.6.6-3),
               python-all-dbg (>= 2.6.6-3),
               python-all-dev (>= 2.6.6-3),
               python-configobj (>= 4.7.2+ds-2),
               python-coverage,
               python-dulwich (>= 0.19.8),
               python-docutils,
               python-fastimport (>= 0.9.8),
               python-meliae-dbg,
               python-paramiko,
               python-sphinx (>= 1.0.7+dfsg),
               python-subunit,
               cython3-dbg (>= 0.17),
               python3 (>= 2.6.6-3),
               python3-all-dbg (>= 2.6.6-3),
               python3-all-dev (>= 2.6.6-3),
               python3-configobj (>= 4.7.2+ds-2),
               python3-coverage <!nocheck>,
               python3-dulwich (>= 0.19.8),
               python3-docutils,
               python3-fastimport (>= 0.9.8),
               python3-paramiko,
               python3-sphinx (>= 1.0.7+dfsg),
               python3-subunit <!nocheck>,
               python3-testtools (>= 0.9.5~) <!nocheck>
Build-Conflicts: python-pyftpdlib
Standards-Version: 4.2.1
Vcs-Bzr: https://code.breezy-vcs.org/breezy/unstable
Vcs-Browser: https://code.breezy-vcs.org/breezy/unstable
Homepage: https://www.breezy-vcs.org/

Package: brz
Recommends: python3-gpg, python3-dulwich (>= 0.19.8)
Architecture: all
Depends: python3-breezy (<= ${source:Version}.1~),
         python3-breezy (>= ${source:Version}),
         ${misc:Depends},
         ${python:Depends}
Conflicts: bzr (<< 2.7.0+bzr6622-1)
Suggests: brz-doc,
          python3-breezy.tests,
          python3-fastimport (>= 0.9.8)
Description: easy to use distributed version control system
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many file formats and workflows, reliable,
 and easily extendable.
 .
 Out of the box, Breezy supports both the Git and Bazaar repository
 formats.
 .
 Install python3-paramiko if you are going to push branches to remote
 hosts with sftp.

Package: python-breezy
Architecture: any
Section: python
Depends: python-configobj,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: ca-certificates,
            python-launchpadlib,
            ssh-client | python-paramiko,
            python-dulwich (>= 0.19.8),
            python-gpg,
Conflicts: python-paramiko (<< 1.14.1)
Suggests: python-breezy-dbg,
          python-breezy.tests,
          python-fastimport,
          python-kerberos (>= 1.0+svn2455-1),
          python-paramiko,
          xdg-utils
Provides: ${python:Provides}
Description: distributed version control system - python 2 library
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many file formats and workflows, reliable,
 and easily extendable.
 .
 This package contains the Breezy Python 2 library.
 .
 Install python-paramiko for sftp transport support.

Package: python3-breezy
Architecture: any
Section: python
Depends: python3-configobj,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: ca-certificates,
            python3-launchpadlib,
            ssh-client | python3-paramiko,
            python3-dulwich (>= 0.19.8),
            python3-gpg,
Conflicts: python3-paramiko (<< 1.14.1)
Suggests: python3-breezy-dbg,
          python3-breezy.tests,
          python3-fastimport,
          python3-kerberos (>= 1.0+svn2455-1),
          python3-paramiko,
          xdg-utils
Provides: ${python3:Provides}
Description: distributed version control system - python 3 library
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many file formats and workflows, reliable,
 and easily extendable.
 .
 This package contains the Breezy Python 3 library.
 .
 Install python3-paramiko for sftp transport support.

Package: python-breezy.tests
Architecture: all
Section: python
Depends: python-breezy (<= ${source:Version}.1~),
         python-breezy (>= ${source:Version}),
         python-testtools (>= 0.9.5~),
         ${misc:Depends},
         ${python:Depends}
Suggests: python-subunit
Provides: ${python:Provides}
Replaces: python-breezy (<< 2.4.0~beta1-2)
Description: distributed version control system - Python 2 testsuite
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many file formats and workflows, reliable,
 and easily extendable.
 .
 This package contains the breezy test infrastructure and testsuite,
 which is required to run the 'brz selftest' command and to run
 plugin tests.
 .
 This package contains the Python 2 version.

Package: python3-breezy.tests
Architecture: all
Section: python
Depends: python3-breezy (<= ${source:Version}.1~),
         python3-breezy (>= ${source:Version}),
         python3-testtools (>= 0.9.5~),
         ${misc:Depends},
         ${python3:Depends}
Suggests: python3-subunit
Provides: ${python3:Provides}
Replaces: python3-breezy (<< 2.4.0~beta1-2)
Description: distributed version control system - Python 3 testsuite
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many file formats workflows, reliable, and
 easily extendable.
 .
 This package contains the breezy test infrastructure and testsuite,
 which is required to run the 'brz selftest' command and to run
 plugin tests.
 .
 This package contains the Python 3 version.

Package: brz-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: brz
Description: easy to use distributed version control system (documentation)
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many file formats and workflows, reliable,
 and easily extendable.
 .
 This package provides the documentation.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# Get the default Python version
PYVERSION = $(shell pyversions -d -v)
PY3VERSION = $(shell py3versions -d -v)

export PYBUILD_NAME=breezy

%:
	dh $* --with python2,python3,sphinxdoc,bash_completion  --buildsystem=pybuild

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
CONCURRENCY = BRZ_CONCURRENCY=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	[ -d debian/brzhome ] || mkdir debian/brzhome
	$(CONCURRENCY) \
	BRZ_HOME=debian/brzhome \
	BRZ_PLUGIN_PATH=-site:-user \
	LC_ALL=C.UTF-8 \
	PYTHONPATH=$(CURDIR)/.pybuild/cpython2_$(PYVERSION)_breezy/build \
	$(shell pyversions -d) ./brz -Derror selftest -v --parallel=fork \
	-Oselftest.timeout=6000
	$(CONCURRENCY) \
	BRZ_HOME=debian/brzhome \
	BRZ_PLUGIN_PATH=-site:-user \
	LC_ALL=C.UTF-8 \
	PYTHONPATH=$(CURDIR)/.pybuild/cpython3_$(PY3VERSION)_breezy/build \
	$(shell py3versions -d) ./brz -Derror selftest -v --parallel=fork \
	-Oselftest.timeout=6000
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/brzhome
	rm -f brzlib/*_pyx.c
	# It also doesn't really clean every thing...
	ls doc/en/user-reference/*txt | grep -v readme.txt | xargs rm -rf
	rm -rf doc/developers/make.bat \
		doc/developers/Makefile \
		doc/*/_build/ \
		doc/en/release-notes/index.txt

override_dh_install:
	dh_install
	find debian/
	mkdir -p debian/python-breezy.tests/usr/lib \
		debian/python-breezy.tests/usr/share/pyshared/breezy
	for py in $(shell pyversions -r); do \
		mkdir -p debian/python-breezy.tests/usr/lib/$$py/dist-packages/breezy; \
		mv debian/python-breezy/usr/lib/$$py/dist-packages/breezy/tests \
			debian/python-breezy.tests/usr/lib/$$py/dist-packages/breezy/tests; \
	done
	for py in $(shell py3versions -r); do \
		mkdir -p debian/python3-breezy.tests/usr/lib/$$py/dist-packages/breezy; \
		mv debian/python3-breezy/usr/lib/$$py/dist-packages/breezy/tests \
			debian/python3-breezy.tests/usr/lib/$$py/dist-packages/breezy/tests; \
	done
	# Install the documentation; since html and txt and intermixed
	# under doc/, this is handier than trying to do it from brz-doc.install.
	( cd doc && find -name "*.txt" -not -wholename "*/_build/*" -print0 ) | \
		xargs -r0 -i'{}' -n1 install -D -m 644 'doc/{}' \
		"debian/brz-doc/usr/share/doc/brz/txt/{}"
	rm debian/python-breezy-dbg/usr/man/man1/brz.1 \
		debian/python-breezy-dbg/usr/man/man1/git-remote-bzr.1 \
		debian/python-breezy-dbg/usr/bin/bzr-receive-pack \
		debian/python-breezy-dbg/usr/bin/brz \
		debian/python-breezy-dbg/usr/bin/bzr-upload-pack \
		debian/python-breezy-dbg/usr/bin/git-remote-bzr
	rmdir debian/python-breezy-dbg/usr/man/man1 \
		  debian/python-breezy-dbg/usr/man
	rm debian/python-breezy/usr/man/man1/brz.1 \
		debian/python-breezy/usr/man/man1/git-remote-bzr.1 \
		debian/python-breezy/usr/bin/bzr-receive-pack \
		debian/python-breezy/usr/bin/brz \
		debian/python-breezy/usr/bin/bzr-upload-pack \
		debian/python-breezy/usr/bin/git-remote-bzr
	rmdir debian/python-breezy/usr/man/man1 \
		  debian/python-breezy/usr/man
	rm debian/python3-breezy/usr/man/man1/brz.1 \
		debian/python3-breezy/usr/man/man1/git-remote-bzr.1 \
		debian/python3-breezy/usr/bin/bzr-receive-pack \
		debian/python3-breezy/usr/bin/brz \
		debian/python3-breezy/usr/bin/bzr-upload-pack \
		debian/python3-breezy/usr/bin/git-remote-bzr
	rmdir debian/python3-breezy/usr/man/man1 \
		  debian/python3-breezy/usr/man
	rm debian/python3-breezy-dbg/usr/man/man1/brz.1 \
		debian/python3-breezy-dbg/usr/man/man1/git-remote-bzr.1 \
		debian/python3-breezy-dbg/usr/bin/bzr-receive-pack \
		debian/python3-breezy-dbg/usr/bin/brz \
		debian/python3-breezy-dbg/usr/bin/bzr-upload-pack \
		debian/python3-breezy-dbg/usr/bin/git-remote-bzr
	rmdir debian/python3-breezy-dbg/usr/man/man1 \
		  debian/python3-breezy-dbg/usr/man

override_dh_auto_missing:
	dh_missing --fail-missing

override_dh_auto_build:
	dh_auto_build
	PYTHONHASHSEED=0 $(MAKE) docs-sphinx

override_dh_compress:
	dh_compress -X.xvg -X.pdf

override_dh_strip:
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	dh_strip -ppython-breezy --dbgsym-migration='python-breezy-dbg (<< 3.0.0~bzr7141-2)'
	dh_strip -ppython3-breezy --dbgsym-migration='python3-breezy-dbg (<< 3.0.0~bzr7141-2)'
endif

override_dh_link:
	# symlink identical resources.
	( cd debian/brz-doc/usr/share/doc && fdupes -o name -r1q . | while read s; do \
	      set -- $$(echo $$s | tr ' ' '\n' | sort); \
	      f=$$1; shift; \
	      for d; do \
		  ln -sf /usr/share/doc/"$$d" "$$f"; \
	      done; \
	done )
	dh_link

override_dh_sphinxdoc:
ifneq "$(shell dh_listpackages | grep -- -doc)" ""
	dh_sphinxdoc -X searchtools.js
endif
	# dh_sphinxdoc chokes if we delete the extra licence files before it runs.
	find debian/brz-doc/usr/share/doc/brz -name "licence.txt" -print | xargs rm -f

=== debian/tests/control ===
Tests: testsuite2
Depends: brz, python-breezy.tests, python-subunit, ca-certificates, python-meliae, python-lzma, python-dulwich (>= 0.19.8), python-coverage
Restrictions: allow-stderr

Tests: testsuite3
Depends: brz, python3-breezy.tests, python3-subunit, ca-certificates, python3-dulwich (>= 0.19.8), python3-coverage
Restrictions: allow-stderr

## breezy 3.0.0~bzr7290

=== debian/changelog ===
breezy (3.0.0~bzr7290-2) unstable; urgency=medium

  * Add patch 21_lp_set_description: fix setting of descriptions on
    Launchpad proposals.
  * Add patch 22_print_warnings: cope with spurious warnings
    during tests.
  * Add patch 23_homedir_location: fix references to ~/.bazaar in
    documentation.
  * Add patch 24_git_symlink_push: support pushing directories
    being converted to symlinks to Git.
  * Add patch 24_revno_order: Raise proper error message
    when passing in out of bounds revnos.
  * Add patch 25_segmentsurl: print proper error when
    segment paths without = is used.
  * Add patch 27_pkgimport_conf: remove references to
    deleted pkgimport.conf
  * Add patch 28_cat_revision_git: print proper error
    when attempting to use 'brz cat-revision' on git repositories.
  * Add patch 29_stacked_on_location: Support directory references
    in --stacked-on parameters.
  * Add patch 30_git_fixes: fix git-remote-brz imports.
  * Drop patch 20_fix_stream_buffering: applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 27 Feb 2019 03:17:10 +0000

breezy (3.0.0~bzr7290-1) unstable; urgency=medium

  * New upstream snapshot.
  * Drop patch 22_git_push_branch_tags: applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 15 Feb 2019 23:48:03 +0000

breezy (3.0.0~bzr7286-2) unstable; urgency=medium

  * Add patch 20_fix_stream_buffering: fix prompts.
  * Add 22_git_push_branch_tags: fix pushing of tags to nascent git
    branches.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 15 Feb 2019 04:25:57 +0000

breezy (3.0.0~bzr7286-1) unstable; urgency=medium

  * Bump cython version to 0.29.1; older versions fail to generate C
    code that works with Python 3.7.
  * Add patch 19_probe_url: support probing based on URL.
  * Explicitly add conflicts with older versions of Dulwich, which break
    breezy.
  * Add patch 16_generate_ids, which provides breezy.generate_ids
    for backwards compatibility with older versions of brz-debian.
  * New upstream snapshot.
  * Drop patch 11_git_wt_reference, merged upstream.
  * Drop patch 13_dulwich_compat, merged upstream.
  * Drop patch 14_fix_fastexport, merged upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 15 Feb 2019 00:20:39 +0000

breezy (3.0.0~bzr7268-2) unstable; urgency=medium

  * Add missing dependency on python{3,}-launchpadlib in debian/tests.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Tue, 12 Feb 2019 21:33:45 +0000

breezy (3.0.0~bzr7268-1) unstable; urgency=medium

  * Add patch 11_git_wt_reference. Necessary for #921240 in lintian-
    brush.
  * Add patch 13_dulwich_compat: fix compatibility with newer versions
    of Dulwich.
  * Add patch 14_fix_fastexport: Fix some fastexport operations.
  * Add patch 15_git_wt_reference: Do not consider .git files unknown.
  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 07 Feb 2019 05:26:11 +0000

breezy (3.0.0~bzr7260-1) unstable; urgency=medium

  * New upstream snapshot.
  * Drop 10_httplib2_import: applied upstream.
  * Add patches: 09_propose_close, 10_propose_base_url.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 01 Feb 2019 00:47:41 +0000

breezy (3.0.0~bzr7254-1) unstable; urgency=medium

  * New upstream snapshot.
   + Drop various patches now merged upstream.
  * Fix capitalization of Python in description.
  * Stop creating empty directory /usr/share/pyshared/breezy.
  * brz: set -e in postinst/prerm scripts.
  * Add overrides for lintian warnings about empty directories; they're
    fine in bzr.
  * Add patch 10_httplib2_import: avoid dependency on httplib2.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 27 Jan 2019 22:11:45 +0000

breezy (3.0.0~bzr7240-1) unstable; urgency=medium

  * Add patches 14_hg_field, 15_verify_signatures_py3: deal with unknown
    HG fields in Git commits, verify signatures correctly on Python 3.
  * Add patch 16_archive_tree_timestamp: generate consistent timestamps
    when exporting tarballs.
  * New upstream snapshot.
  * Drop patch 11_pack_signature: applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 13 Jan 2019 18:34:14 +0000

breezy (3.0.0~bzr7239-2) unstable; urgency=medium

  * Add patch 13_gz: do not accidentally interpret temporary file name
    as zip.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 12 Jan 2019 01:22:11 +0000

breezy (3.0.0~bzr7239-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add patch 11_pack_signature: fix repacking of commits with
    signatures on Python 3. Closes: #918723.
  * Drop patch 10_my_proposals: applied upstream.
  * Add patch 12_gpg_default: support 'default' setting for
    gpg_signing_key.
  * Bump standards version to 12.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 09 Jan 2019 00:10:16 +0000

breezy (3.0.0~bzr7236-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add patch 10_my_proposals: add new hidden 'brz my-proposals' command.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 05 Jan 2019 15:05:23 +0000

breezy (3.0.0~bzr7233-1) unstable; urgency=medium

  * New upstream snapshot.
   + Recommend gitlab, github and launchpadlib libraries for new propose
     functionality.
   + Drop patch 09_fix_spurious: applied upstream.
   + Drop patch 09_python_3.7: applied upstream.
   + Drop patch 10_timestamp_limit: applied upstream.
   + Drop patch 11_non_utf8_locale: applied upstream.
  * Bump debhelper to 11.
  * Bump standards version to 4.3.0.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Tue, 18 Dec 2018 21:04:12 +0000

breezy (3.0.0~bzr7210-4) unstable; urgency=medium

  * debian/control: Remove notes about paramiko in description.
  * add patch 11_non_utf8_locale: fix selftest when running with non-
    utf8 locale.
  * Re-export upstream signing key without extra signatures.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Tue, 04 Dec 2018 22:47:14 +0000

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,19 @@
 Uploaders: Jelmer Vernooĳ <jelmer@debian.org>
 Build-Depends: bash-completion,
                ca-certificates,
-               cython-dbg (>= 0.17) <!nocheck>,
+               cython-dbg (>= 0.29.1) <!nocheck>,
                dh-python,
-               debhelper (>= 9.20160114),
+               debhelper (>= 12),
                fdupes,
                python (>= 2.6.6-3),
                python-all-dbg (>= 2.6.6-3),
                python-all-dev (>= 2.6.6-3),
                python-configobj (>= 4.7.2+ds-2),
                python-coverage,
-               python-dulwich (>= 0.19.8),
+               python-dulwich (>= 0.19.11),
                python-docutils,
                python-fastimport (>= 0.9.8),
+               python-launchpadlib,
                python-meliae-dbg,
                python-paramiko,
                python-sphinx (>= 1.0.7+dfsg),
@@ -27,21 +28,22 @@
                python3-all-dev (>= 2.6.6-3),
                python3-configobj (>= 4.7.2+ds-2),
                python3-coverage <!nocheck>,
-               python3-dulwich (>= 0.19.8),
+               python3-dulwich (>= 0.19.11),
                python3-docutils,
                python3-fastimport (>= 0.9.8),
+               python3-launchpadlib,
                python3-paramiko,
                python3-sphinx (>= 1.0.7+dfsg),
                python3-subunit <!nocheck>,
                python3-testtools (>= 0.9.5~) <!nocheck>
 Build-Conflicts: python-pyftpdlib
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Bzr: https://code.breezy-vcs.org/breezy/unstable
 Vcs-Browser: https://code.breezy-vcs.org/breezy/unstable
 Homepage: https://www.breezy-vcs.org/
 
 Package: brz
-Recommends: python3-gpg, python3-dulwich (>= 0.19.8)
+Recommends: python3-gpg, python3-dulwich (>= 0.19.11)
 Architecture: all
 Depends: python3-breezy (<= ${source:Version}.1~),
          python3-breezy (>= ${source:Version}),
@@ -58,9 +60,6 @@
  .
  Out of the box, Breezy supports both the Git and Bazaar repository
  formats.
- .
- Install python3-paramiko if you are going to push branches to remote
- hosts with sftp.
 
 Package: python-breezy
 Architecture: any
@@ -71,10 +70,12 @@
          ${shlibs:Depends}
 Recommends: ca-certificates,
             python-launchpadlib,
+            python-github,
+            python-gitlab,
             ssh-client | python-paramiko,
-            python-dulwich (>= 0.19.8),
+            python-dulwich (>= 0.19.11),
             python-gpg,
-Conflicts: python-paramiko (<< 1.14.1)
+Conflicts: python-paramiko (<< 1.14.1), python-dulwich (<< 0.19.11)
 Suggests: python-breezy-dbg,
           python-breezy.tests,
           python-fastimport,
@@ -82,14 +83,12 @@
           python-paramiko,
           xdg-utils
 Provides: ${python:Provides}
-Description: distributed version control system - python 2 library
+Description: distributed version control system - Python 2 library
  Breezy is a distributed version control system designed to be easy to
  use and intuitive, able to adapt to many file formats and workflows, reliable,
  and easily extendable.
  .
  This package contains the Breezy Python 2 library.
- .
- Install python-paramiko for sftp transport support.
 
 Package: python3-breezy
 Architecture: any
@@ -100,25 +99,25 @@
          ${shlibs:Depends}
 Recommends: ca-certificates,
             python3-launchpadlib,
+            python3-github,
+            python3-gitlab,
             ssh-client | python3-paramiko,
-            python3-dulwich (>= 0.19.8),
+            python3-dulwich (>= 0.19.11),
             python3-gpg,
-Conflicts: python3-paramiko (<< 1.14.1)
+Conflicts: python3-paramiko (<< 1.14.1), python3-dulwich (<< 0.19.11)
 Suggests: python3-breezy-dbg,
           python3-breezy.tests,
           python3-fastimport,
           python3-kerberos (>= 1.0+svn2455-1),
           python3-paramiko,
-          xdg-utils
+          xdg-utils,
 Provides: ${python3:Provides}
-Description: distributed version control system - python 3 library
+Description: distributed version control system - Python 3 library
  Breezy is a distributed version control system designed to be easy to
  use and intuitive, able to adapt to many file formats and workflows, reliable,
  and easily extendable.
  .
  This package contains the Breezy Python 3 library.
- .
- Install python3-paramiko for sftp transport support.
 
 Package: python-breezy.tests
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -51,8 +51,7 @@
 override_dh_install:
 	dh_install
 	find debian/
-	mkdir -p debian/python-breezy.tests/usr/lib \
-		debian/python-breezy.tests/usr/share/pyshared/breezy
+	mkdir -p debian/python-breezy.tests/usr/lib
 	for py in $(shell pyversions -r); do \
 		mkdir -p debian/python-breezy.tests/usr/lib/$$py/dist-packages/breezy; \
 		mv debian/python-breezy/usr/lib/$$py/dist-packages/breezy/tests \

=== debian/tests/control ===
Tests: testsuite2
Depends: brz, python-breezy.tests, python-subunit, ca-certificates, python-meliae, python-lzma, python-dulwich (>= 0.19.11), python-coverage, python-launchpadlib
Restrictions: allow-stderr

Tests: testsuite3
Depends: brz, python3-breezy.tests, python3-subunit, ca-certificates, python3-dulwich (>= 0.19.11), python3-coverage, python3-launchpadlib
Restrictions: allow-stderr

## breezy 3.0.0

=== debian/changelog ===
breezy (3.0.0-1) experimental; urgency=medium

  * New upstream release.
   + Drop various patches applied upstream: 21_lp_set_description,
   22_print_warnings, 23_homedir_location, 24_git_symlink_push,
   25_segmentsurl, 27_pkgimport_conf, 28_cat_revision_git,
   29_stacked_on_location, 30_git_fixes.
  * Drop conflicts with pyftpdlib; Breezy no longer supports FTP.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 06 Mar 2019 21:44:24 +0000

=== debian/control ===
--- 
+++ 
@@ -36,10 +36,9 @@
                python3-sphinx (>= 1.0.7+dfsg),
                python3-subunit <!nocheck>,
                python3-testtools (>= 0.9.5~) <!nocheck>
-Build-Conflicts: python-pyftpdlib
 Standards-Version: 4.3.0
-Vcs-Bzr: https://code.breezy-vcs.org/breezy/unstable
-Vcs-Browser: https://code.breezy-vcs.org/breezy/unstable
+Vcs-Bzr: https://code.breezy-vcs.org/breezy/experimental
+Vcs-Browser: https://code.breezy-vcs.org/breezy/experimental
 Homepage: https://www.breezy-vcs.org/
 
 Package: brz
